"use strict";

function _interopRequireDefault(a) {
    return a && a.__esModule ? a : {
        "default": a
    }
}
var _set = require("babel-runtime/core-js/set"),
    _set2 = _interopRequireDefault(_set),
    _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of"),
    _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf),
    _classCallCheck2 = require("babel-runtime/helpers/classCallCheck"),
    _classCallCheck3 = _interopRequireDefault(_classCallCheck2),
    _createClass2 = require("babel-runtime/helpers/createClass"),
    _createClass3 = _interopRequireDefault(_createClass2),
    _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn"),
    _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2),
    _inherits2 = require("babel-runtime/helpers/inherits"),
    _inherits3 = _interopRequireDefault(_inherits2),
    path = require("path"),
    Observable = require("orion-core/lib/Observable"),
    console = require("orion-core/lib/util/console-manager").console,
    xfs = require("orion-core/lib/xfs"),
    requirePrefix = xfs.getRelativePath(xfs.resolve(__dirname), global.dirname),
    CLI = function(a) {
        function b() {
            return (0, _classCallCheck3["default"])(this, b), (0, _possibleConstructorReturn3["default"])(this, (0, _getPrototypeOf2["default"])(b).apply(this, arguments))
        }
        return (0, _inherits3["default"])(b, a), (0, _createClass3["default"])(b, [{
            key: "ctor",
            value: function() {
                var a = this,
                    b = a._yargs = require("yargs").usage("Usage: $0 command").command("run", "run test scenario").command("server", "start archive server").demand(1, "must provide a valid command").epilog("Copyright Sencha 2015"),
                    c = a._argv = b.argv;
                a._command = c._[0], a._boundCommands = new _set2["default"]
            }
        }, {
            key: "execute",
            value: function() {
                var a = this,
                    b = a._command;
                console.log("Sencha Test v1.0.1".bold), a._boundCommands.has(b) ? a[b]() : (this._yargs.showHelp(), process.exit(1))
            }
        }, {
            key: "bind",
            value: function(a, b) {
                var c = this;
                c._boundCommands.add(a), c.on(a, function(a) {
                    var c = require(xfs.join(global.dirname, b)),
                        d = new c(a);
                    d.execute()
                })
            }
        }, {
            key: "run",
            value: function() {
                var a = this._yargs.reset().usage("$0 run -o output -p pool [-s scenario] [--notunnel]").usage("$0 run -o output -p pool [-s scenario]").option("o", {
                    alias: "output",
                    "default": "text",
                    describe: "Output format",
                    choices: ["text", "junit", "teamcity"],
                    type: "string"
                }).option("p", {
                    alias: "pool",
                    demand: !0,
                    describe: "Browser pool name",
                    type: "string"
                }).option("s", {
                    alias: "scenario",
                    describe: "Path to test scenario",
                    type: "string"
                }).option("u", {
                    alias: "user",
                    describe: "Username for the browser farm *",
                    type: "string"
                }).option("k", {
                    alias: "key",
                    describe: "Access key for the browser farm *",
                    type: "string"
                }).option("c", {
                    alias: "callbackAddress",
                    describe: "Address trough which browsers can connect to the local machine, if other than localhost",
                    type: "string"
                }).option("S", {
                    alias: "archiveServer",
                    describe: "Archive server address",
                    type: "string"
                }).option("K", {
                    alias: "storageKey",
                    describe: "Key to the storage area",
                    type: "string"
                }).option("n", {
                    alias: "buildnumber",
                    describe: "Build number",
                    type: "string"
                }).option("b", {
                    alias: "baseline",
                    describe: "Path to the baseline dir",
                    type: "string"
                }).option("C", {
                    alias: "coverage",
                    describe: "Enables code coverage",
                    type: "boolean"
                }).option("a", {
                    alias: "archivedir",
                    describe: "Path where the results archives are stored",
                    type: "string"
                }).option("t", {
                    alias: "timeout",
                    describe: "Browser communication timeout (ms)",
                    type: "string"
                }).option("cmd", {
                    describe: "Sencha Cmd path",
                    type: "string"
                }).epilogue("* SauceLabs and BrowserStack only").help("h").alias("help").argv;
                this.fire({
                    type: "run",
                    output: a.o,
                    poolName: a.p,
                    scenarioDir: a.s ? path.resolve(a.s) : process.cwd(),
                    username: a.u,
                    accessKey: a.k,
                    callbackAddress: a.callbackAddress,
                    autoStartTunnel: a.notunnel !== !0,
                    archiveServer: a.S,
                    storageKey: a.K,
                    buildNumber: a.n,
                    baselinedir: a.b,
                    coverage: a.coverage,
                    workdir: a.archivedir,
                    timeout: a.timeout,
                    cmdPath: a.cmd ? path.resolve(a.cmd) : null,
                    argv: a
                })
            }
        }, {
            key: "server",
            value: function() {
                var a = this._yargs.reset().usage("$0 server").option("s", {
                    alias: "storage",
                    describe: "The path to the storage.json file",
                    type: "string"
                }).option("p", {
                    alias: "port",
                    describe: "Server port",
                    type: "string"
                }).argv;
                this.fire({
                    type: "server",
                    storageRoot: a.storage,
                    port: a.port,
                    argv: a
                })
            }
        }, {
            key: "upload",
            value: function() {
                var a = this._yargs.reset().usage("$0 upload -s server -a archive").option("S", {
                    alias: "server",
                    demand: !0,
                    describe: "Server address",
                    type: "string"
                }).option("a", {
                    alias: "archive",
                    demand: !0,
                    describe: "Archive",
                    type: "string"
                }).option("p", {
                    alias: "archivePath",
                    describe: "Archive path within the storage area",
                    type: "string"
                }).option("K", {
                    alias: "key",
                    demand: !0,
                    describe: "Key to the storage area",
                    type: "string"
                }).help("h").alias("help").argv;
                this.fire({
                    type: "upload",
                    server: a.S,
                    archive: a.a,
                    archivePath: a.p,
                    storageKey: a.K,
                    argv: a
                })
            }
        }, {
            key: "download",
            value: function() {
                var a = this._yargs.reset().usage("$0 upload -s server -p path").option("s", {
                    alias: "server",
                    demand: !0,
                    describe: "Server Address",
                    type: "string"
                }).option("r", {
                    alias: "root",
                    describe: 'Server Archive Root (required if no "key" is specified)',
                    type: "string"
                }).option("k", {
                    alias: "key",
                    describe: "Key to the storage area",
                    type: "string"
                }).option("p", {
                    alias: "path",
                    demand: !0,
                    describe: "Server Path",
                    type: "string"
                }).option("l", {
                    alias: "localPath",
                    demand: !0,
                    describe: "Local Path",
                    type: "string"
                }).help("h").alias("help").argv;
                a.k || a.r || (this._yargs.showHelp(), process.exit(1)), this.fire({
                    type: "download",
                    server: a.s,
                    root: a.r,
                    storageKey: a.k,
                    path: a.p,
                    localPath: a.l,
                    argv: a
                })
            }
        }, {
            key: "merge",
            value: function() {
                var a = this._yargs.reset().usage("$0 merge archive1 archive2").demand(2).help("h").alias("help").argv;
                this.fire({
                    type: "merge",
                    archive1: a._[1],
                    archive2: a._[2],
                    argv: a
                })
            }
        }]), b
    }(Observable);
module.exports = new CLI;
