"use strict";

function _interopRequireDefault(a) {
    return a && a.__esModule ? a : {
        "default": a
    }
}
var _promise = require("babel-runtime/core-js/promise"),
    _promise2 = _interopRequireDefault(_promise),
    _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of"),
    _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf),
    _classCallCheck2 = require("babel-runtime/helpers/classCallCheck"),
    _classCallCheck3 = _interopRequireDefault(_classCallCheck2),
    _createClass2 = require("babel-runtime/helpers/createClass"),
    _createClass3 = _interopRequireDefault(_createClass2),
    _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn"),
    _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2),
    _inherits2 = require("babel-runtime/helpers/inherits"),
    _inherits3 = _interopRequireDefault(_inherits2),
    App = require("orion-core/lib/model/cmd/App"),
    ArchiveReporter = require("orion-core/lib/reporter/ArchiveReporter"),
    CmdClient = require("orion-core/lib/cmd/Client"),
    CmdManager = require("orion-core/lib/cmd/Manager"),
    File = require("orion-core/lib/fs/File"),
    Observable = require("orion-core/lib/Observable"),
    Project = require("orion-core/lib/model/test/Project"),
    Runner = require("orion-core/lib/test/Runner"),
    Workspace = require("orion-core/lib/model/Workspace"),
    xfs = require("orion-core/lib/xfs"),
    Url = require("url"),
    JUnitReporter = require("./reporter/JUnitReporter"),
    TeamCityReporter = require("./reporter/TeamCityReporter"),
    TextReporter = require("./reporter/TextReporter"),
    reporterMap = {
        archive: ArchiveReporter,
        junit: JUnitReporter,
        teamcity: TeamCityReporter,
        text: TextReporter
    },
    console = require("orion-core/lib/util/console-manager").console,
    RunCommand = function(a) {
        function b() {
            return (0, _classCallCheck3["default"])(this, b), (0, _possibleConstructorReturn3["default"])(this, (0, _getPrototypeOf2["default"])(b).apply(this, arguments))
        }
        return (0, _inherits3["default"])(b, a), (0, _createClass3["default"])(b, [{
            key: "execute",
            value: function execute() {
                var a = this,
                    b = a.scenarioDir,
                    c = a.poolName,
                    d = a.cmdManager = new CmdManager;
                a.cmdPath && (d.current = new CmdClient({
                    manager: d,
                    directory: a.cmdPath
                })), Workspace.find(b).then(function(a) {
                    return Workspace.load(a)
                }).then(function(d) {
                    var e = d.getTestScenario(b);
                    a._assertNotNull(e, "No test scenario found on " + b);
                    var f = a._getPool(c, d),
                        g = a._getArchivePath(d, e.project.owner);
                    a._runScenario(e, {
                        pool: f,
                        output: a.output,
                        archivePath: g
                    })
                })["catch"](function(a) {
                    console.error(a.stack || a), process.exit(1)
                })
            }
        }, {
            key: "_getArchivePath",
            value: function _getArchivePath(a, b) {
                var c = "",
                    d = a.get("tests");
                if (d && d.archivePath && (c = d.archivePath), b.isApp || b.isPackage) {
                    var e = b.get("tests");
                    e && e.archivePath && (c += e.archivePath)
                }
                return c
            }
        }, {
            key: "_runScenario",
            value: function _runScenario(a, b) {
                var c = this,
                    d = b.archivePath,
                    e = b.pool,
                    f = c._getRunner(a, d);
                f.startProxy(), f.proxy.on("error", function(a) {
                    console.error(a.stack || a)
                }), f.on("terminated", function() {
                    _promise2["default"].all([f.archiver.flush(), e.farm.stopTunnel ? e.farm.stopTunnel() : _promise2["default"].resolve()]).then(function(a) {
                        a.forEach(function(a) {
                            a && console.log(a)
                        }), setTimeout(function() {
                            process.exit()
                        }, 1e3)
                    })["catch"](function(a) {
                        console.error(a.stack || a), setTimeout(function() {
                            process.exit(1)
                        }, 1e3)
                    })
                });
                var g = _promise2["default"].resolve(),
                    h = a.project.owner;
                h.isApp && h.get("launchAppWatch") && (g = g.then(h.launch(a.get("profile")))), g.then(function() {
                    var b = {
                        globals: a.getGlobals()
                    };
                    f.startTestRun({
                        files: a.getFiles(),
                        browsers: e.browsers,
                        enableCodeCoverage: c.coverage,
                        testOptions: b
                    })
                })["catch"](function(a) {
                    console.error(a.stack || a), process.exit(1)
                })
            }
        }, {
            key: "_getRunner",
            value: function _getRunner(a, b) {
                var c, d = this,
                    e = Array.isArray(d.output) ? d.output : [d.output],
                    f = a.getCalculatedTargetUrl(),
                    g = Url.parse(f),
                    h = new ArchiveReporter({
                        id: d.buildNumber,
                        scenario: a,
                        server: d.archiveServer,
                        storageKey: d.storageKey,
                        archivePath: b,
                        workdir: d.workdir,
                        baselinedir: d.baselinedir && new File(d.baselinedir)
                    }),
                    i = [h];
                e.forEach(function(c) {
                    "archive" !== c && i.push(new reporterMap[c]({
                        scenario: a,
                        archivePath: b
                    }))
                }), g.hostname || (c = !0);
                var j = new Runner({
                    port: 8e3,
                    scenario: a,
                    cmdClient: d.cmdManager.current,
                    archiver: h,
                    reporter: i,
                    noProxy: c,
                    callbackAddress: d.callbackAddress,
                    enableCodeCoverage: d.coverage,
                    autoStartTunnel: d.autoStartTunnel,
                    remoteTimeout: d.timeout
                });
                return j
            }
        }, {
            key: "_assertNotNull",
            value: function _assertNotNull(a, b) {
                null == a && (console.error(b), process.exit())
            }
        }, {
            key: "_getPool",
            value: function _getPool(a, b) {
                var c = this,
                    d = [];
                b.eachFarm(function(b) {
                    d = d.concat(b.getPools(a))
                });
                var e = c._validatePool(d, a, b);
                return c.username && e.farm.set("username", c.username), c.accessKey && e.farm.set("accessKey", c.accessKey), e
            }
        }, {
            key: "_validatePool",
            value: function _validatePool(a, b, c) {
                var d = a.length && a[0],
                    e = [];
                return d ? a.length > 1 ? e.push("Multiple found by name: " + b) : d.farm || e.push("Pool " + d.name + " is not associated with a browser farm") : e.push("No such browser pool: " + b), e.length && (e.push(""), e.push("Available browser pools:"), c.eachFarm(function(a) {
                    a.eachPool(function(a) {
                        e.push("    " + a.name)
                    })
                }), console.error(e.join("\n")), process.exit(1)), d
            }
        }]), b
    }(Observable);
module.exports = RunCommand;
